"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deserialize = void 0;
const constants_1 = require("../constants");
const findNodeBySelector_1 = require("./findNodeBySelector");
const deserialize = (result, document) => {
    const range = document.createRange();
    let startNode = (0, findNodeBySelector_1.findNodeBySelector)(result.s, document);
    let endNode = (0, findNodeBySelector_1.findNodeBySelector)(result.e, document);
    if (startNode.nodeType !== constants_1.DOM_NODE_TEXT_NODE && startNode.firstChild) {
        startNode = startNode.firstChild;
    }
    if (endNode.nodeType !== constants_1.DOM_NODE_TEXT_NODE && endNode.firstChild) {
        endNode = endNode.firstChild;
    }
    if (startNode) {
        range.setStart(startNode, result.s.o);
    }
    if (endNode) {
        range.setEnd(endNode, result.e.o);
    }
    return range;
};
exports.deserialize = deserialize;
